import org.junit.Test;

import static org.junit.Assert.*;
import fi.helsinki.cs.tmc.edutestutils.Points;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;

@Points("10.2")
public class MainTest {
    private String kaarilista(int[] mista, int[] minne) {
        String tulos = "";
        for (int i = 0; i < mista.length; i++) {
            if (tulos.equals("")) tulos = mista[i] + "->" + minne[i];
            else tulos += ", "  + mista[i] + "->" + minne[i];
        }
        return "[" + tulos + "]";
    }
    
    public void pieniTesti(int n, int[] mista, int[] minne) {
        int[] jarj=Main.jarjesta(n, mista, minne);
        int[] inv=new int[n+1];
        for(int i=1; i<=n; i++)
            inv[i]=-1;
        
        for(int i=0; i<jarj.length; i++){
            assertTrue("Algoritmisi palauttama taulukko on virheellinen: siinä esiintyy jokin luku, joka ei ole välillä 1.."+n+".", 1<=jarj[i] && jarj[i]<=n);
            assertTrue("Algoritmisi palauttama taulukko on virheellinen: siinä esiintyy jokin luku kahdesti.", inv[jarj[i]]==-1);
            inv[jarj[i]]=i;
        }
        
        for(int i=1; i<=n; i++)
            assertTrue("Algoritmisi palauttama taulukko on virheellinen: siitä puuttuu jokin verkon solmuista.", inv[i]!=-1);
        
        for(int i=0; i<mista.length; i++){
            assertTrue("Kun annetun verkon kaaret ovat "+kaarilista(mista, minne)+",\n"
                    +"palauttaa algoritmisi järjestyksen "+Arrays.toString(jarj)+",\n"
                    + "joka ei ole topologinen järjestys.", inv[mista[i]] <= inv[minne[i]]);
        }
    }
    
    public void suuriTesti(int n, int[] mista, int[] minne) {
        int[] jarj=Main.jarjesta(n, mista, minne);
        int[] inv=new int[n+1];
        for(int i=1; i<=n; i++)
            inv[i]=-1;
        
        for(int i=0; i<jarj.length; i++){
            assertTrue("Algoritmisi palauttama taulukko on virheellinen: siinä esiintyy jokin luku, joka ei ole välillä 1.."+n+".", 1<=jarj[i] && jarj[i]<=n);
            assertTrue("Algoritmisi palauttama taulukko on virheellinen: siinä esiintyy jokin luku kahdesti.", inv[jarj[i]]==-1);
            inv[jarj[i]]=i;
        }
        
        for(int i=1; i<=n; i++)
            assertTrue("Algoritmisi palauttama taulukko on virheellinen: siitä puuttuu jokin verkon solmuista.", inv[i]!=-1);
        
        for(int i=0; i<mista.length; i++){
            assertTrue("Algoritmisi palauttaa väärän järjestyksen suurella syötteellä.", inv[mista[i]] <= inv[minne[i]]);
        }
    }
    
    @Test(timeout=1000)
    public void esimerkit() {
        pieniTesti(3, new int[] {3, 2}, new int[] {2, 1});
        pieniTesti(3, new int[] {1}, new int[] {2});
        pieniTesti(5, new int[] {1,5,2,3}, new int[] {5,2,3,4});
        pieniTesti(5, new int[] {1,3,2}, new int[] {3,5,4});
    }
    
    static class Random {
        private long val;
        private long mul=16807;
        private long mod=((long)1<<31)-1;
        private long get(){
            val=(val*mul)%mod;
            return val;
        }
        public int getInt(int a, int b){
            return a+Math.abs((int)get()%(b-a+1));
        }
        public int getIntW(int a, int b, int w){
            int r=getInt(a, b);
            for (int i=1;i<=w;i++){
                r=Math.max(r, getInt(a, b));
            }
            for (int i=-1;i>=w;i--){
                r=Math.min(r, getInt(a, b));
            }
            return r;
        }
        public Random(int seed){
            val=seed;
        }
    }
    
    public void testaaPieniRandom(int n, int m, int seed){
        int[] mista=new int[m];
        int[] mihin=new int[m];
        
        Random rng=new Random(seed);
        for(int i=0; i<m; i++){
            mista[i]=rng.getInt(1, n);
            mihin[i]=rng.getInt(1, n);
            while(mihin[i]==mista[i])
                mihin[i]=rng.getInt(1, n);
        }
        pieniTesti(n, mista, mihin);
    }
    
    public void testaaSuuriRandom(int n, int m, int seed){
        int[] mista=new int[m];
        int[] mihin=new int[m];
        
        Random rng=new Random(seed);
        for(int i=0; i<m; i++){
            mista[i]=rng.getInt(1, n);
            mihin[i]=rng.getInt(1, n);
            while(mihin[i]==mista[i])
                mihin[i]=rng.getInt(1, n);
        }
        suuriTesti(n, mista, mihin);
    }
    
    @Test(timeout=1000)
    public void pienet() {
        testaaPieniRandom(10, 10, 78127878);
        testaaPieniRandom(10, 10, 801980811);
        testaaPieniRandom(10, 10, 999191919);
        testaaPieniRandom(10, 10, 111111111);
        testaaPieniRandom(10, 10, 562341211);
        testaaPieniRandom(10, 10, 415123511);
        testaaPieniRandom(10, 10, 124661231);
        testaaPieniRandom(10, 10, 611351211);
        testaaPieniRandom(10, 10, 61611616);
        testaaPieniRandom(10, 10, 999999999);
        testaaPieniRandom(10, 10, 451255511);
    }
    
    @Test(timeout=1000)
    public void suuri1() {
        testaaSuuriRandom(100000, 90000, 712683718);
    }
    
    @Test(timeout=1000)
    public void suuri2() {
        testaaSuuriRandom(100000, 60000, 112122341);
    }
    
    @Test(timeout=1000)
    public void suuri3() {
        testaaSuuriRandom(100000, 90000, 102983111);
    }
    
    @Test(timeout=1000)
    public void suuri4() {
        testaaSuuriRandom(100000, 90000, 102983111);
    }
    
    @Test(timeout=1000)
    public void suuri5() {
        testaaSuuriRandom(100000, 90000, 1273192311);
    }
    
    @Test(timeout=1000)
    public void suuri6() {
        int n=100000;
        int[] mista=new int[n-1];
        int[] mihin=new int[n-1];
        
        Random rng=new Random(71279791);
        
        for(int i=0; i<n-1; i++){
            mista[i]=i+1;
            mihin[i]=rng.getInt(i+2, n);
        }
        
        suuriTesti(n, mista, mihin);
    }
    
    @Test(timeout=1000)
    public void suuri7() {
        int n=100000;
        int[] mista=new int[n-1];
        int[] mihin=new int[n-1];
        
        Random rng=new Random(471236811);
        
        for(int i=0; i<n-1; i++){
            mista[i]=i+1;
            mihin[i]=rng.getInt(i+2, n);
        }
        
        suuriTesti(n, mista, mihin);
    }
    
    @Test(timeout=1000)
    public void suuri8() {
        int n=90000;
        int lisa=5000;
        int[] mista=new int[n-1 + lisa];
        int[] mihin=new int[n-1 + lisa];
        
        Random rng=new Random(112931238);
        
        for(int i=0; i<n-1; i++){
            mista[i]=i+1;
            mihin[i]=rng.getInt(i+2, n);
        }
        
        for(int i=90000-1; i<90000+lisa-1; i++){
            mista[i]=rng.getInt(1, n);
            mihin[i]=rng.getInt(1, n);
            while(mihin[i]==mista[i])
                mihin[i]=rng.getInt(1, n);
        }
        
        suuriTesti(n, mista, mihin);
    } 
    
    @Test(timeout=1000)
    public void suuri9() {
        int n=90000;
        int lisa=10000;
        int[] mista=new int[n-1 + lisa];
        int[] mihin=new int[n-1 + lisa];
        
        Random rng=new Random(18273912);
        
        for(int i=0; i<n-1; i++){
            mista[i]=i+1;
            mihin[i]=rng.getInt(i+2, n);
        }
        
        for(int i=90000-1; i<90000+lisa-1; i++){
            mista[i]=rng.getInt(1, n);
            mihin[i]=rng.getInt(1, n);
            while(mihin[i]==mista[i])
                mihin[i]=rng.getInt(1, n);
        }
        
        suuriTesti(n, mista, mihin);
    } 
    
    @Test(timeout=1000)
    public void suuri10() {
        int n=90000;
        int lisa=10000;
        int[] mista=new int[n-1 + lisa];
        int[] mihin=new int[n-1 + lisa];
        
        Random rng=new Random(376777777);
        
        for(int i=0; i<n-1; i++){
            mista[i]=i+1;
            mihin[i]=rng.getInt(i+2, n);
        }
        
        for(int i=90000-1; i<90000+lisa-1; i++){
            mista[i]=rng.getInt(1, n);
            mihin[i]=rng.getInt(1, n);
            while(mihin[i]==mista[i])
                mihin[i]=rng.getInt(1, n);
        }
        
        suuriTesti(n, mista, mihin);
    } 
}

